Summary: MPI Benchmarks and tests
Name: mpitests
Version: 3.1
Release: 5%{?dist}
License: BSD
Group: Applications
Source: mpitests-%{version}.tar.gz
Patch0: mpitests-2.0-make.patch
Provides: mpitests
BuildRoot: /var/tmp/%{name}-%{version}-%{release}-root
# mvapich2 only exists on these three arches
ExclusiveArch: i386 x86_64 ia64

%description
Set of popular MPI benchmarks:
IMB-2.3
Presta-1.4.0
OSU benchmarks ver 2.2

%package openmpi
Summary: MPI tests package compiled against openmpi
Group: Applications
BuildRequires: openmpi, openmpi-devel
Requires: openmpi
%description openmpi
MPI test suite compiled against the openmpi package

%package mvapich
Summary: MPI tests package compiled against mvapich
Group: Applications
BuildRequires: mvapich, libibverbs-devel, libibumad-devel, libibcommon-devel
BuildRequires: gcc4
Requires: mvapich
%description mvapich
MPI test suite compiled against the mvapich package

%package mvapich2
Summary: MPI tests package compiled against mvapich2
Group: Applications
BuildRequires: mvapich2, libibverbs-devel, libibumad-devel, libibcommon-devel
BuildRequires: librdmacm-devel, gcc4
Requires: mvapich2
%description mvapich2
MPI test suite compiled against the mvapich2 package

%prep
%setup -q
%patch0 -p1 -b .make

%build
# Have to build in the install step

%install
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-Wp,-D_FORTIFY_SOURCE=.//' | sed -e 's/-fstack-protector//'`
# do three builds, one for each mpi stack
OLD_PATH="$PATH"
OLD_LD_PATH="$LD_CONFIG_PATH"
# The filesystem package should *always* be installed, so if we can't do an
# rpm -q on it, then rpm -q isn't working at all and fall back to another
# method to get our version
(rpm -q filesystem >/dev/null 2>&1)
RPM_QUERY=$?
MPI=openmpi
[ $RPM_QUERY -eq 0 ] && VERSION=`rpm -q --queryformat="%%{version}-gcc\n" $MPI.%{_arch} | head -1` || VERSION=`ls -1U %{_libdir}/$MPI/ | tail -1`
MPI_BIN=%{_libdir}/$MPI/$VERSION/bin
MPI_LIB=%{_libdir}/$MPI/$VERSION/lib
PATH=$MPI_BIN:$OLD_PATH
LD_CONFIG_PATH=$MPI_LIB:$OLD_LD_PATH
make CC=mpicc CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" all
mkdir -p %{buildroot}$MPI_BIN
make DESTDIR=%{buildroot} INSTALL_DIR=$MPI_BIN install
make clean
MPI=mvapich
[ $RPM_QUERY -eq 0 ] && VERSION=`rpm -q --queryformat="%%{version}-gcc4\n" $MPI.%{_arch} | head -1` || VERSION=`ls -1U %{_libdir}/$MPI/ | tail -1`
MPI_BIN=%{_libdir}/$MPI/$VERSION/bin
MPI_LIB=%{_libdir}/$MPI/$VERSION/lib
PATH=$MPI_BIN:$OLD_PATH
LD_CONFIG_PATH=$MPI_LIB:$OLD_LD_PATH
# mvapich is an MPI-1 level implementation and doesn't do many of the benchmarks
make CC=mpicc CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" osu-mpi1 presta
mkdir -p %{buildroot}$MPI_BIN
make DESTDIR=%{buildroot} INSTALL_DIR=$MPI_BIN install-osu install-presta
make clean
MPI=mvapich2
[ $RPM_QUERY -eq 0 ] && VERSION=`rpm -q --queryformat="%%{version}-gcc4\n" $MPI.%{_arch} | head -1` || VERSION=`ls -1U %{_libdir}/$MPI/ | tail -1`
MPI_BIN=%{_libdir}/$MPI/$VERSION/bin
MPI_LIB=%{_libdir}/$MPI/$VERSION/lib
PATH=$MPI_BIN:$OLD_PATH
LD_CONFIG_PATH=$MPI_LIB:$OLD_LD_PATH
make CC=mpicc CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" all
mkdir -p %{buildroot}$MPI_BIN
make DESTDIR=%{buildroot} INSTALL_DIR=$MPI_BIN install

%clean
rm -rf %{buildroot}

%files openmpi
%defattr(-, root, root, -)
%{_libdir}/openmpi/*/bin/*

%files mvapich
%defattr(-, root, root, -)
%{_libdir}/mvapich/*/bin/*

%files mvapich2
%defattr(-, root, root, -)
%{_libdir}/mvapich2/*/bin/*

%changelog
* Mon Oct 19 2009 Doug Ledford <dledford@redhat.com> - 3.1-5
- Another take on the build system fix.
- Related: bz484126

* Sun Oct 18 2009 Doug Ledford <dledford@redhat.com> - 3.1-4
- Another take on the build system fix.
- Related: bz484126

* Mon Oct 05 2009 Doug Ledford <dledford@redhat.com> - 3.1-3
- Fix build issue when there is more than one mpi version for a given
  mpi implementation installed (or when there are just dangling directories
  from an older installation)
- Related: bz484126

* Sun Sep 13 2009 Doug Ledford <dledford@redhat.com> - 3.1-2
- Fix build with latest mvapich and mvapich2 packages
- Resolves: bz484126

* Mon Jan 26 2009 Doug Ledford <dledford@redhat.com> - 3.1-1
- Update to latest version
- Related: bz481599

* Thu Sep 18 2008 Doug Ledford <dledford@redhat.com> - 3.0-2
- Add no-strict-aliasing compile flag to silence warnings

* Thu Sep 18 2008 Doug Ledford <dledford@redhat.com> - 3.0-1
- Update to latest upstream version
- Compile three times against the three mpi stacks and make three packages
- Resolves: bz451474

* Mon Jan 22 2007 Doug Ledford <dledford@redhat.com> - 2.0-2
- Recreate lost spec file and patches from memory
- Add dist tag to release
- Turn off FORTIFY_SOURCE when building

